<ion-header>
  <ion-toolbar>
    <ion-buttons slot="start">
      <ion-button (click)="navigateBack()">
        <ion-icon slot="icon-only" name="arrow-back"></ion-icon>
      </ion-button>
    </ion-buttons>
    <ion-title>Stock Ledger Report</ion-title>
  </ion-toolbar>
</ion-header>

<div class="loading-shade" *ngIf="dataSource.loading$ | async">
  <mat-progress-bar
    *ngIf="dataSource.loading$ | async"
    mode="indeterminate"
  ></mat-progress-bar>
</div>

<ion-content color="light">
  <ion-card>
    <ion-card-header>
      <ion-card-title>
        <ion-text color="primary">
          Stock Ledger
        </ion-text>
      </ion-card-title>
    </ion-card-header>
    
    <ion-card-content class="ion-no-padding">
      <form [formGroup]="stockLedgerForm">
        <ion-grid>
          <ion-row>
            
          </ion-row>
          <ion-row>
            <ion-col>
              <mat-form-field 
                class="mat-input-wrapper">
                <input
                  matInput
                  placeholder="Item name"
                  [matAutocomplete]="itemName"
                  formControlName="item_name"
                  (focusout)="validateInput(f.itemName, filteredStockAvailabilityList)"
                />
                <mat-autocomplete
                  autoActiveFirstOption
                  #itemName="matAutocomplete"
                  [displayWith]="getStockAvailabilityOption"
                  (optionSelected)="setFilter()"
                >
                  <mat-option
                    *ngFor="let option of filteredStockAvailabilityList | async"
                    [value]="option"
                  >
                    {{ option.item_name }}
                  </mat-option>
                </mat-autocomplete>
                <mat-error *ngIf="f.item_name.hasError('falseValse')">
                  You should select a value from dropdown only.
                  <strong>
                    '{{f.itemName.value}}'
                  </strong> is not allowed.
                </mat-error>
              </mat-form-field>
            </ion-col>
            <ion-col>
              <mat-form-field class="mat-input-wrapper">
                <input
                  matInput
                  placeholder="Warehouse"
                  [matAutocomplete]="warehouse"
                  formControlName="warehouse"
                  (focusout)="validateInput(f.warehouse, filteredWarehouseList)"
                />
                <mat-autocomplete
                  autoActiveFirstOption
                  #warehouse="matAutocomplete"
                  (optionSelected)="setFilter()"
                >
                  <mat-option
                    *ngFor="let option of filteredWarehouseList | async"
                    [value]="option"
                  >
                    {{ option }}
                  </mat-option>
                </mat-autocomplete>
                <mat-error *ngIf="f.warehouse.hasError('falseValse')">
                  You should select a value from dropdown only.
                  <strong>'{{f.warehouse.value}}'</strong> is not allowed.
                </mat-error>
              </mat-form-field>
            </ion-col>
            <!-- <ion-col>
              <mat-form-field 
                class="mat-input-wrapper">
                <input
                  type="text"
                  placeholder="Project"
                  matInput
                  formControlName="project"
                  (focusout)="validateInput(f.project, filteredProjectList)"
                  [matAutocomplete]="project"
                />
                <mat-autocomplete
                  autoActiveFirstOption
                  #project="matAutocomplete"
                >
                  <mat-option
                    *ngFor="let project of filteredProjectList | async"
                    [value]="project.name"
                  >
                    {{ project.name }}
                  </mat-option>
                </mat-autocomplete>
                <mat-error *ngIf="f.project.hasError('falseValse')">
                  You should select a value from dropdown only.
                  <strong>
                    '{{ f.project.value }}'
                  </strong> is not allowed.
                </mat-error>
              </mat-form-field>
            </ion-col> -->
            <ion-col>
              <mat-form-field 
                class="mat-input-wrapper">
                <input
                  matInput
                  placeholder="Voucher No."
                  formControlName="voucher"
                  (keyup.enter)="setFilter()"
                />
              </mat-form-field>
            </ion-col>
          </ion-row>
          <ion-row>
            
            <ion-col>
              <mat-form-field 
                class="mat-input-wrapper">
                <input
                  matInput
                  placeholder="Item Group"
                  [matAutocomplete]="itemGroupAutocomplete"
                  formControlName="excel_item_group"
                  (focusout)="validateInput(f.excel_item_group, filteredItemGroupList)"
                />
                <mat-autocomplete
                  autoActiveFirstOption
                  #itemGroupAutocomplete="matAutocomplete"
                  [displayWith]="getItemGroupOption"
                  (optionSelected)="setFilter()"
                >
                  <mat-option
                    *ngFor="let option of filteredItemGroupList | async"
                    [value]="option"
                  >
                    {{ option.item_group_name }}
                  </mat-option>
                </mat-autocomplete>
                <mat-error *ngIf="f.excel_item_group.hasError('falseValse')">
                  You should select a value from dropdown only.
                  <strong>'{{f.excel_item_group.value}}'</strong> is not allowed.
                </mat-error>
              </mat-form-field>
            </ion-col>
            <ion-col>
              <mat-form-field class="mat-input-wrapper">
                <mat-label>Voucher Type</mat-label>
                <mat-select
                  formControlName="voucher_type"
                  (selectionChange)="setFilter()"
                >
                  <mat-option
                    *ngFor="let type of VoucherType"
                    [value]="type"
                  >
                    {{type}}
                  </mat-option>
                </mat-select>
              </mat-form-field>
            </ion-col>
            <ion-col>
              <mat-form-field 
                class="mat-input-wrapper">
                <input
                  matInput
                  placeholder="Brand"
                  [matAutocomplete]="itemBrandAutocomplete"
                  formControlName="excel_item_brand"
                  (focusout)="validateInput(f.excel_item_brand, filteredItemBrandList)"
                />
                <mat-autocomplete
                  autoActiveFirstOption
                  #itemBrandAutocomplete="matAutocomplete"
                  [displayWith]="getItemBrandOption"
                  (optionSelected)="setFilter()"
                >
                  <mat-option
                    *ngFor="let option of filteredItemBrandList | async"
                    [value]="option"
                  >
                    {{ option.brand }}
                  </mat-option>
                </mat-autocomplete>
                <mat-error *ngIf="f.excel_item_brand.hasError('falseValse')">
                  You should select a value from dropdown only.
                  <strong>'{{f.excel_item_brand.value}}'</strong> is not allowed.
                </mat-error>
              </mat-form-field>
            </ion-col>
          </ion-row>
          <ion-row>
            <ion-col>
              <div class="search-models ">
                <mat-form-field appearance="fill">
                  <mat-label>
                    Enter a date range
                  </mat-label>
                  <mat-date-range-input 
                    [formGroup]="stockLedgerForm" 
                    [rangePicker]="picker" >
                    <input 
                      matStartDate 
                      formControlName="start_date" 
                      placeholder="Start date">
                    <input 
                      matEndDate
                      formControlName="end_date" 
                      placeholder="End date" 
                      (dateChange)="setFilter()">
                  </mat-date-range-input>
                  <mat-hint>
                    MM/DD/YYYY – MM/DD/YYYY
                  </mat-hint>
                  <mat-datepicker-toggle 
                    matSuffix
                    [for]="picker">
                  </mat-datepicker-toggle>
                  <mat-date-range-picker 
                    #picker>
                  </mat-date-range-picker>                
                  <mat-error *ngIf="f.start_date.hasError('matStartDateInvalid')">
                    Invalid start date
                  </mat-error>
                  <mat-error *ngIf="f.end_date.hasError('matEndDateInvalid')">
                    Invalid end date
                  </mat-error>
                </mat-form-field>
              </div>
            </ion-col>
            <ion-button
                (click)="clearFilters()"
                fill="outline"
                color="tertiary"
              >
                Clear
              </ion-button>
               <ion-button
                color="tertiary"

                (click)="downloadStockLedgerReport()"
                fill="outline"
              >
                Download CSV
            </ion-button>
          </ion-row>  
        </ion-grid>
      </form>

      <div class="example-container mat-elevation-z8">
        <table
          mat-table
          class="full-width-table"
          [dataSource]="dataSource"
          matSort
        >
          <ng-container matColumnDef="posting_date">
            <mat-header-cell *matHeaderCellDef>Date</mat-header-cell>
            <mat-cell *matCellDef="let row">{{ row.posting_date | date: 'd MMM, y' }}</mat-cell>
          </ng-container>

          <ng-container matColumnDef="item_code">
            <mat-header-cell *matHeaderCellDef>Item code</mat-header-cell>
            <mat-cell *matCellDef="let row">{{ row.item.item_code }}</mat-cell>
          </ng-container>

          <ng-container matColumnDef="item_name">
            <mat-header-cell *matHeaderCellDef>Item Name</mat-header-cell>
            <mat-cell *matCellDef="let row">{{ row.item.item_name }}</mat-cell>
          </ng-container>

          <ng-container matColumnDef="warehouse">
            <mat-header-cell *matHeaderCellDef>Warehouse</mat-header-cell>
            <mat-cell *matCellDef="let row">{{ row.warehouse }}</mat-cell>
          </ng-container>

          <ng-container matColumnDef="brand">
            <mat-header-cell *matHeaderCellDef>Item brand</mat-header-cell>
            <mat-cell *matCellDef="let row">{{ row.item.brand }}</mat-cell>
          </ng-container>
          
          <!-- <ng-container matColumnDef="batch_no">
            <mat-header-cell *matHeaderCellDef>Batch No.</mat-header-cell>
            <mat-cell *matCellDef="let row">{{ row.batch_no }}</mat-cell>
          </ng-container> -->

          <ng-container matColumnDef="voucher_no">
            <mat-header-cell *matHeaderCellDef>Voucher No.</mat-header-cell>
            <mat-cell *matCellDef="let row">{{ row.voucher_no }}</mat-cell>
          </ng-container>

          <ng-container matColumnDef="balance_qty">
            <mat-header-cell *matHeaderCellDef>Balance Qty</mat-header-cell>
            <mat-cell *matCellDef="let row">{{ row.balance_qty }}</mat-cell>
          </ng-container>

          <ng-container matColumnDef="balance_value">
            <mat-header-cell *matHeaderCellDef>Balance Value</mat-header-cell>
            <mat-cell *matCellDef="let row">{{ row.balance_value }}</mat-cell>
          </ng-container>

          <ng-container matColumnDef="item_group">
            <mat-header-cell *matHeaderCellDef>Item Group</mat-header-cell>
            <mat-cell *matCellDef="let row">{{ row.item.item_group }}</mat-cell>
          </ng-container>

          <ng-container matColumnDef="stock_uom">
            <mat-header-cell *matHeaderCellDef>Stock UOM</mat-header-cell>
            <mat-cell *matCellDef="let row">{{ row.item.stock_uom }}</mat-cell>
          </ng-container>

          <ng-container matColumnDef="voucher_type">
            <mat-header-cell *matHeaderCellDef>Voucher Type</mat-header-cell>
            <mat-cell *matCellDef="let row">{{ row.voucher_type }}</mat-cell>
          </ng-container>

          <ng-container matColumnDef="actual_qty">
            <mat-header-cell *matHeaderCellDef>Actual quantity</mat-header-cell>
            <mat-cell *matCellDef="let row">{{ row.actual_qty }}</mat-cell>
          </ng-container>

          <ng-container matColumnDef="incoming_rate">
            <mat-header-cell *matHeaderCellDef>Incoming Rate</mat-header-cell>
            <mat-cell *matCellDef="let row">{{ row.incoming_rate }}</mat-cell>
          </ng-container>

          <ng-container matColumnDef="outgoing_rate">
            <mat-header-cell *matHeaderCellDef>Outgoing Rate</mat-header-cell>
            <mat-cell *matCellDef="let row">{{ row.outgoing_rate }}</mat-cell>
          </ng-container>

          <ng-container matColumnDef="valuation_rate">
            <mat-header-cell *matHeaderCellDef>Valuation Rate</mat-header-cell>
            <mat-cell *matCellDef="let row">{{ row.valuation_rate }}</mat-cell>
          </ng-container>

          <mat-header-row *matHeaderRowDef="displayedColumns; sticky: true">
          </mat-header-row>

          <mat-row *matRowDef="let row; columns: displayedColumns"> </mat-row>
        </table>
      </div>
      <mat-card-actions>
        <mat-paginator
          #paginator
          class="mat-paginator-sticky"
          (page)="getUpdate($event)"
          [length]="dataSource.length"
          [pageSizeOptions]="[30, 50, 100, 500,1000]"
        >
        </mat-paginator>
      </mat-card-actions>
    </ion-card-content>
  </ion-card>
</ion-content>

